spandsp: v29tx.h File Reference

spandsp 0.0.6

Typedefs | Functions | Variables
v29tx.h File Reference

Go to the source code of this file.

## Typedefs
typedef struct v29_tx_state_s | v29_tx_state_t

## Functions
void | v29_tx_power (v29_tx_state_t *s, float power)
| Adjust a V.29 modem transmit context's output power.
v29_tx_state_t * | v29_tx_init (v29_tx_state_t *s, int bit_rate, int tep, get_bit_func_t get_bit, void *user_data)
| Initialise a V.29 modem transmit context.
int | v29_tx_restart (v29_tx_state_t *s, int bit_rate, int tep)
| Reinitialise an existing V.29 modem transmit context.
int | v29_tx_release (v29_tx_state_t *s)
| Release a V.29 modem transmit context.
int | v29_tx_free (v29_tx_state_t *s)
| Free a V.29 modem transmit context.
logging_state_t * | v29_tx_get_logging_state (v29_tx_state_t *s)
| Get the logging context associated with a V.29 modem transmit context.
void | v29_tx_set_get_bit (v29_tx_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.29 modem transmit context.
void | v29_tx_set_modem_status_handler (v29_tx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.29 modem transmit context.
| SPAN_DECLARE_NONSTD (int) v29_tx(v29_tx_state_t *s
| Generate a block of V.29 modem audio samples.

## Variables
int16_t | amp []
int16_t int | len

## Typedef Documentation

## ◆ v29_tx_state_t

typedef struct v29_tx_state_s v29_tx_state_t

V.29 modem transmit side descriptor. This defines the working state for a single instance of a V.29 modem transmitter.

## Function Documentation

## ◆ SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Generate a block of V.29 modem audio samples.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Get the next bit of a transmitted serial bit stream.

Generate a block of V.29 modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples to be generated.

Returns
  The number of samples actually generated.

## ◆ v29_tx_free()

int v29_tx_free | ( | v29_tx_state_t * | s | ) |

Free a V.29 modem transmit context.

Free a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v29_tx_get_logging_state()

logging_state_t * v29_tx_get_logging_state | ( | v29_tx_state_t * | s | ) |

Get the logging context associated with a V.29 modem transmit context.

Get the logging context associated with a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v29_tx_state_s::logging.

## ◆ v29_tx_init()

v29_tx_state_t * v29_tx_init | ( | v29_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | get_bit_func_t | get_bit,
|  | void * | user_data
| ) |  |

Initialise a V.29 modem transmit context.

Initialise a V.29 modem transmit context. This must be called before the first use of the context, to initialise its contents.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 4800, 7200 and 9600.
  tep | TRUE is the optional TEP tone is to be transmitted.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v29_tx_state_s::carrier_phase_rate, v29_tx_state_s::get_bit, v29_tx_state_s::get_bit_user_data, v29_tx_state_s::logging, v29_tx_power(), and v29_tx_restart().

## ◆ v29_tx_power()

void v29_tx_power | ( | v29_tx_state_t * | s,
|  | float | power
| ) |  |

Adjust a V.29 modem transmit context's output power.

Adjust a V.29 modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References v29_tx_state_s::base_gain.

Referenced by v29_tx_init().

## ◆ v29_tx_release()

int v29_tx_release | ( | v29_tx_state_t * | s | ) |

Release a V.29 modem transmit context.

Release a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v29_tx_restart()

int v29_tx_restart | ( | v29_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep
| ) |  |

Reinitialise an existing V.29 modem transmit context.

Reinitialise an existing V.29 modem transmit context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 4800, 7200 and 9600.
  tep | TRUE is the optional TEP tone is to be transmitted.

Returns
  0 for OK, -1 for bad parameter

References v29_tx_state_s::baud_phase, v29_tx_state_s::bit_rate, v29_tx_state_s::carrier_phase, v29_tx_state_s::constellation_state, v29_tx_state_s::current_get_bit, v29_tx_state_s::in_training, v29_tx_state_s::logging, v29_tx_state_s::rrc_filter, v29_tx_state_s::rrc_filter_step, v29_tx_state_s::scramble_reg, span_log(), v29_tx_state_s::training_offset, v29_tx_state_s::training_scramble_reg, v29_tx_state_s::training_step, V29_TRAINING_SEG_1, and V29_TRAINING_SEG_TEP.

Referenced by v29_tx_init().

## ◆ v29_tx_set_get_bit()

void v29_tx_set_get_bit | ( | v29_tx_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data
| ) |  |

Change the get_bit function associated with a V.29 modem transmit context.

Change the get_bit function associated with a V.29 modem transmit context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v29_tx_state_s::current_get_bit, v29_tx_state_s::get_bit, and v29_tx_state_s::get_bit_user_data.

## ◆ v29_tx_set_modem_status_handler()

void v29_tx_set_modem_status_handler | ( | v29_tx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data
| ) |  |

Change the modem status report function associated with a V.29 modem transmit context.

Change the modem status report function associated with a V.29 modem transmit context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v29_tx_state_s::status_handler, and v29_tx_state_s::status_user_data.